; The humble pope Neige the reversing schemer and avatar of lazyness
; officially declares this script dumper for Dragon Ball Z - Super Gokuuden Totsugeki Hen (J)
; to be (K) 3176 YOLD
; Do what thou wilt with thine copy

#lang scheme/base

(require racket/format
         "libs/table.ss"
         "libs/memmap.ss"
         "libs/io.ss")

(define rom-name "DBZ-SGTH-orig.smc")

(define table (make-table 'extraction))
(table 'read-table "data-jp\\DlgFont.tbl")

(set-default-mapper! snes-lorom-mapper)
(set-io-big-endian! #f)

(define (snes-get-bank addr)
  (bitwise-and (arithmetic-shift addr -16) #xFF))

;; read-ptr : natural-number/c input-port? -> (values natural-number/c natural-number/c)
;; reads the pointer at address addr from the input-port ip
;; and returns the pointer read and the address of the next pointer
#;(define (read-ptr addr ip) ...)

;; make-16bits-pointer-reader : natural-number/c -> (-> natural-number/c input-port? -> (values natural-number/c natural-number/c))
;; return a read-ptr procedure that return a pointer that points to a specific bank
(define (make-16bits-pointer-reader bank)
  (λ (addr ip)
    (values (bitwise-ior (arithmetic-shift bank 16)
                         (read-word-at ip (snes-lorom-mapper addr)))
            (+ addr 2))))

;; read-16bits-ptr : natural-number/c input-port? -> (values natural-number/c natural-number/c)
;; read a snes 16-bits pointer pointing in the same bank as the pointer itself
(define (read-16bits-ptr addr ip)
  (values (bitwise-ior (bitwise-and addr #xFF0000)
                       (read-word-at ip (snes-lorom-mapper addr)))
          (+ addr 2)))

;; read-ptr-table : natural-number/c (-> natural-number/c input-port? (values natural-number/c natural-number/c)) natural-number/c input-port? (-> natural-number/c natural-number/c natural-number/c) -> pair?
(define (read-ptr-table addr read-ptr num ip [ptr-mod #f])
  (define hash (make-hash))
  (define (hash-add! h k v)
    (hash-set! h k (cons v (hash-ref h k '()))))
  (let rpt-loop ([addr addr] [i 0])
    (unless (= num i)
      (let-values ([(ptr next-addr) (read-ptr addr ip)]
                   [(val) (if ptr-mod (ptr-mod addr i) addr)])
        (hash-add! hash ptr val)
        (rpt-loop next-addr (add1 i)))))
  (sort (hash-map hash
                  (λ (k v)
                    (list k v)))
        <
        #:key car))

(define (format-snes-ptr p)
  (~r p #:base '(up 16) #:min-width 6 #:pad-string "0"))

(define (format-snes-ptr-list lop)
  (map (λ (p)
         (format "#x~a" (~r p #:base '(up 16) #:min-width 6 #:pad-string "0")))
       lop))

(define (make-id-maker str [use-suffix? #t])
  (if use-suffix?
      (λ (num)
        (string->symbol (format "~a-~a" str (~r num #:min-width 5 #:pad-string "0"))))
      (λ (num)
        str)))
;((make-id-maker "Test") 0)

(define (make-dump-line-maker write-func dest [align-args #f] [ptr-mod #f])
  (λ (ptr id)
    (let ([ptrs (if ptr-mod (map ptr-mod (cadr ptr)) (cadr ptr))])
      (format "(~a ~a ~a ((~a ~a)))\n"
              id
              dest
              align-args
              write-func
              (format-snes-ptr-list ptrs)))))

#;-
(define (read-string rip table [addr #f])
  (and addr (map-position rip addr))
  (let rs-loop ([len (table 'get-max-length)]
                [word (peek-bytes (table 'get-max-length) 0 rip)])
    (if (zero? len)
        (begin
          (bytes-append (string->bytes/latin-1 (format "<$~a><$~a>"
                                                            (~r (read-byte rip) #:base '(up 16) #:min-width 2 #:pad-string "0")
                                                            (~r (read-byte rip) #:base '(up 16) #:min-width 2 #:pad-string "0")))
                        (rs-loop (table 'get-max-length)
                                 (peek-bytes (table 'get-max-length) 0 rip))))
        (let ([val (table 'get-mapping word #f)])
          (cond
            [(procedure? val)
             (let-values ([(s stop?) (val word rip)])
               (read-bytes len rip) ; read and advance port position
               (bytes-append s (if stop? #"" (rs-loop (table 'get-max-length)
                                                      (peek-bytes (table 'get-max-length) 0 rip)))))]
            [(bytes? val)
             (read-bytes len rip) ; read and advance port position
             (bytes-append val (rs-loop (table 'get-max-length)
                                        (peek-bytes (table 'get-max-length) 0 rip)))]
            [else
             (rs-loop (- len 2)
                      (peek-bytes (- len 2) 0 rip))])))))

;; dump-from-ptr-table : input-port? table pair? path-string? path-string? (-> natural-number/c symbol?) (-> natural-number/c symbol? string?) -> any
(define (dump-from-ptr-table rip table ptrs dump text make-id make-dump-line)
  (let ([dop (open-output-file dump #:mode 'text #:exists 'truncate)]
        [top (open-output-file text #:mode 'text #:exists 'truncate)])
    (for ([ptr (in-list ptrs)]
          [i (in-naturals)])
      (display (make-dump-line ptr (make-id i)) dop)
      (fprintf top "\n[BEGIN ~a]\n//" (make-id i))
      (display (read-string rip table (car ptr)) top)
      (fprintf top "\n~a<END>\n[END]\n" (make-id i)))
    (close-output-port dop)
    (close-output-port top)))

(define (make-btldlg-dump-line ptrs id)
  (format "(~a #xB1 (left ~a 3) ((write-16bits-ptrs ~a)))\n"
          id
          (case id
            [(BtlDlg-00225 BtlDlg-00418 BtlDlg-00420) (* 22 8)]
            [else (* 16 8)])
          (format-snes-ptr-list (cadr ptrs))))

(define make-dialog-dump-line
  (let* ([make-id (make-id-maker "Dialog")]
         [widths (make-immutable-hash
                 (call/if rom-name
                   (λ (ip)
                     (file-position ip #x749BA)
                     (let loop ([n 0])
                       (if (= n 5730)
                           '()
                           (cons (cons (make-id n)
                                       (if (= (bitwise-and (read-word ip) #xFF) #xFF)
                                           (* 22 8)
                                           (* 16 8)))
                                 (loop (add1 n))))))))])
    (λ (ptr id)
      (let ([ptrs (map (λ (c) (+ #x9D8000 (* c 3))) (cadr ptr))])
        (format "(~a #f (left ~a 3) ((write-24bits-ptrs ~a)))\n"
                id
                (hash-ref widths id #;(* 16 8))
                (format-snes-ptr-list ptrs))))))

(call/if rom-name
  (λ (ip)
    (let ([verbose #f])
      (table 'add-mapping #"\x00\x00" (λ (c ip) (values #"<END>" #t)))
      (table 'add-mapping #"\x0A\x00" (λ (c ip) (values #"<EOL>\n//" #f)))
      (and verbose (printf "Dumping NewGame\n"))
      #;-
      (let* ([dop (open-output-file "NewGame.dump" #:mode 'text #:exists 'truncate)]
             [top (open-output-file "data-jp\\NewGame.txt" #:mode 'text #:exists 'truncate)]
             [make-id
              (λ (addr)
                (format "NewGame-~a" (~r addr #:base '(up 16) #:min-width 6 #:pad-string "0")))]
             [make-dump-line
              (λ (addr ptrs)
                (format "(~a ~a #f ((~a ~a)))\n"
                        (make-id addr)
                        (snes-get-bank addr)
                        'write-16bits-ptrs
                        (format-snes-ptr-list ptrs)))]
             [dump-from-ptrs
              (λ (ptrs [num 1])
                (let ([addr (+ (bitwise-and (car ptrs) #xFF0000) (read-word-at ip (snes-lorom-mapper (car ptrs))))])
                  (display (make-dump-line addr ptrs) dop)
                  (fprintf top "\n[BEGIN ~a]\n//" (make-id addr))
                  (display (read-string ip table addr) top)
                  (let loop ([n (sub1 num)])
                    (unless (zero? n)
                      (newline top)
                      (display "//" top)
                      (display (read-string ip table) top)
                      (loop (sub1 n))))
                  (fprintf top "\n~a<END>\n[END]\n" (make-id addr))))])
        (dump-from-ptrs '(#x80E4CD))
        (dump-from-ptrs '(#x80E501))
        (dump-from-ptrs '(#x80E535))
        (dump-from-ptrs '(#x80E473))
        (dump-from-ptrs '(#x80E478))
        (dump-from-ptrs '(#x80CA5D))
        (dump-from-ptrs '(#x80CB82) 2)
        (dump-from-ptrs '(#x80973A #x809DAA #x80EB2C))
        (dump-from-ptrs '(#x809307))
        (dump-from-ptrs '(#x809A01))
        (dump-from-ptrs '(#x809501) 7)
        (dump-from-ptrs '(#x809389))
        (dump-from-ptrs '(#x8093F4))
        (dump-from-ptrs '(#x809435))
        (dump-from-ptrs '(#x809A5D))
        (dump-from-ptrs '(#x809A8B))
        (dump-from-ptrs '(#x809366 #x8094AD))
        (close-output-port dop)
        (close-output-port top))
      (and verbose (printf "Dumping LoadSave\n"))
      #;-
      (let* ([dop (open-output-file "LoadSave.dump" #:mode 'text #:exists 'truncate)]
             [top (open-output-file "data-jp\\LoadSave.txt" #:mode 'text #:exists 'truncate)]
             [make-id
              (λ (addr)
                (format "LoadSave-~a" (format-snes-ptr addr)))]
             [make-dump-line
              (λ (addr ptrs)
                (format "(~a ~a #f ((~a ~a)))\n"
                        (make-id addr)
                        (snes-get-bank addr)
                        'write-16bits-ptrs
                        (format-snes-ptr-list ptrs)))]
             [dump-from-ptrs
              (λ (ptrs [num 1])
                (let ([addr (+ (bitwise-and (car ptrs) #xFF0000) (read-word-at ip (snes-lorom-mapper (car ptrs))))])
                  (display (make-dump-line addr ptrs) dop)
                  (fprintf top "\n[BEGIN ~a]\n//" (make-id addr))
                  (display (read-string ip table addr) top)
                  (let loop ([n (sub1 num)])
                    (unless (zero? n)
                      (newline top)
                      (display "//" top)
                      (display (read-string ip table) top)
                      (loop (sub1 n))))
                  (fprintf top "\n~a<END>\n[END]\n" (make-id addr))))])
        (dump-from-ptrs '(#x809FCB))
        (dump-from-ptrs '(#x80A21F))
        (dump-from-ptrs '(#x81DA28))
        (dump-from-ptrs '(#x81D85A))
        (dump-from-ptrs '(#x81D860))
        (dump-from-ptrs '(#x81D8C1))
        (dump-from-ptrs '(#x81D86E))
        (dump-from-ptrs '(#x81D874))
        (dump-from-ptrs '(#x81D882))
        (dump-from-ptrs '(#x81D6AE))
        (dump-from-ptrs '(#x81D6BF))
        (dump-from-ptrs '(#x81D6D0))
        (dump-from-ptrs '(#x81D6E1))
        (dump-from-ptrs '(#x81D6F2))
        (dump-from-ptrs '(#x81DA23))
        (close-output-port dop)
        (close-output-port top))
      (and verbose (printf "Dumping DebugMenu\n"))
      #;-
      (let* ([dop (open-output-file "DebugMenu.dump" #:mode 'text #:exists 'truncate)]
             [top (open-output-file "data-jp\\DebugMenu.txt" #:mode 'text #:exists 'truncate)]
             [make-id
              (λ (addr)
                (format "DebugMenu-~a" (format-snes-ptr addr)))]
             [make-dump-line
              (λ (addr ptrs)
                (format "(~a ~a #f ((~a ~a)))\n"
                        (make-id addr)
                        (snes-get-bank addr)
                        'write-16bits-ptrs
                        (format-snes-ptr-list ptrs)))]
             [dump-from-ptrs
              (λ (ptrs [num 1])
                (let ([addr (+ (bitwise-and (car ptrs) #xFF0000) (read-word-at ip (snes-lorom-mapper (car ptrs))))])
                  (display (make-dump-line addr ptrs) dop)
                  (fprintf top "\n[BEGIN ~a]\n//" (make-id addr))
                  (display (read-string ip table addr) top)
                  (let loop ([n (sub1 num)])
                    (unless (zero? n)
                      (newline top)
                      (display "//" top)
                      (display (read-string ip table) top)
                      (loop (sub1 n))))
                  (fprintf top "\n~a<END>\n[END]\n" (make-id addr))))])
        (dump-from-ptrs '(#x8287BB)) ; main debug menu
        (dump-from-ptrs '(#x829502))
        (dump-from-ptrs '(#x829DDA))
        (dump-from-ptrs '(#x828F05))
        (dump-from-ptrs '(#x8288E6))
        (dump-from-ptrs '(#x829CDE))
        (dump-from-ptrs '(#x82898D)) ; debug battle strings
        (dump-from-ptrs '(#x828CCD))
        (dump-from-ptrs '(#x828CFA))
        (dump-from-ptrs '(#x828D28))
        (dump-from-ptrs '(#x828D5D))
        (close-output-port dop)
        (close-output-port top))
      (and verbose (printf "Dumping StartScreen\n"))
      #;-
      (let* ([dop (open-output-file "StartScreen.dump" #:mode 'text #:exists 'truncate)]
             [top (open-output-file "data-jp\\StartScreen.txt" #:mode 'text #:exists 'truncate)]
             [make-id
              (λ (addr)
                (format "StartScreen-~a" (format-snes-ptr addr)))]
             [make-dump-line
              (λ (addr ptrs)
                (format "(~a ~a #f ((~a ~a)))\n"
                        (make-id addr)
                        (snes-get-bank addr)
                        'write-16bits-ptrs
                        (format-snes-ptr-list ptrs)))]
             [dump-from-ptrs
              (λ (ptrs [num 1])
                (let ([addr (+ (bitwise-and (car ptrs) #xFF0000) (read-word-at ip (snes-lorom-mapper (car ptrs))))])
                  (display (make-dump-line addr ptrs) dop)
                  (fprintf top "\n[BEGIN ~a]\n//" (make-id addr))
                  (display (read-string ip table addr) top)
                  (let loop ([n (sub1 num)])
                    (unless (zero? n)
                      (newline top)
                      (display "//" top)
                      (display (read-string ip table) top)
                      (loop (sub1 n))))
                  (fprintf top "\n~a<END>\n[END]\n" (make-id addr))))])
        (dump-from-ptrs '(#x80C2BD))
        (dump-from-ptrs '(#x80C2E2))
        (dump-from-ptrs '(#x80C308 #x80C324 #x80C34F #x80C37A) 4)
        (dump-from-ptrs '(#x80C3D7 #x80C415) 2)
        (dump-from-ptrs '(#x80B698))
        (dump-from-ptrs '(#x80B6B0))
        (dump-from-ptrs '(#x80B6BD #x80B6EC) 2)
        (dump-from-ptrs '(#x80B73D))
        (dump-from-ptrs '(#x80BE97))
        (dump-from-ptrs '(#x80BEA4 #x80BEC8) 2)
        (dump-from-ptrs '(#x80C0FA))
        (dump-from-ptrs '(#x80C10C))
        (dump-from-ptrs '(#x80C11E))
        (dump-from-ptrs '(#x80C0E8))
        (dump-from-ptrs '(#x80BB78))
        (dump-from-ptrs '(#x80BB85 #x80BBA9) 2)
        (dump-from-ptrs '(#x80AAA6))
        (dump-from-ptrs '(#x80AABE))
        (dump-from-ptrs '(#x80AAD6 #x80D804))
        (close-output-port dop)
        (close-output-port top))
      (and verbose (printf "Dumping Battle\n"))
      #;-
      (let* ([dop (open-output-file "Battle.dump" #:mode 'text #:exists 'truncate)]
             [top (open-output-file "data-jp\\Battle.txt" #:mode 'text #:exists 'truncate)]
             [make-id
              (λ (addr)
                (format "Battle-~a" (format-snes-ptr addr)))]
             [make-dump-line
              (λ (addr ptrs)
                (format "(~a ~a #f ((~a ~a)))\n"
                        (make-id addr)
                        (snes-get-bank addr)
                        'write-16bits-ptrs
                        (format-snes-ptr-list ptrs)))]
             [dump-from-ptrs
              (λ (ptrs [num 1])
                (let ([addr (+ (bitwise-and (car ptrs) #xFF0000) (read-word-at ip (snes-lorom-mapper (car ptrs))))])
                  (display (make-dump-line addr ptrs) dop)
                  (fprintf top "\n[BEGIN ~a]\n//" (make-id addr))
                  (display (read-string ip table addr) top)
                  (let loop ([n (sub1 num)])
                    (unless (zero? n)
                      (newline top)
                      (display "//" top)
                      (display (read-string ip table) top)
                      (loop (sub1 n))))
                  (fprintf top "\n~a<END>\n[END]\n" (make-id addr))))])
        (dump-from-ptrs '(#xB0ACE3))
        (dump-from-ptrs '(#x80D869))
        (dump-from-ptrs '(#xB786B3))
        (close-output-port dop)
        (close-output-port top))
      (and verbose (printf "Dumping Piccolo\n"))
      #;-
      (let* ([dop (open-output-file "Piccolo.dump" #:mode 'text #:exists 'truncate)]
             [top (open-output-file "data-jp\\Piccolo.txt" #:mode 'text #:exists 'truncate)]
             [make-id
              (λ (addr)
                (format "Piccolo-~a" (format-snes-ptr addr)))]
             [make-dump-line
              (λ (addr ptrs)
                (format "(~a ~a  (left 128 3) ((~a ~a)))\n"
                        (make-id addr)
                        (snes-get-bank addr)
                        'write-16bits-ptrs
                        (format-snes-ptr-list ptrs)))]
             [dump-from-ptrs
              (λ (ptrs [num 1])
                (let ([addr (+ (arithmetic-shift #x8E 16) (read-word-at ip (snes-lorom-mapper (car ptrs))))])
                  (display (make-dump-line addr ptrs) dop)
                  (fprintf top "\n[BEGIN ~a]\n//" (make-id addr))
                  (display (read-string ip table addr) top)
                  (let loop ([n (sub1 num)])
                    (unless (zero? n)
                      (newline top)
                      (display "//" top)
                      (display (read-string ip table) top)
                      (loop (sub1 n))))
                  (fprintf top "\n~a<END>\n[END]\n" (make-id addr))))])
        (dump-from-ptrs '(#x81E300))
        (dump-from-ptrs '(#x81E380))
        (dump-from-ptrs '(#x81E43F))
        (dump-from-ptrs '(#x81E573))
        (dump-from-ptrs '(#x81E69B))
        (dump-from-ptrs '(#x81EB14))
        (dump-from-ptrs '(#x81EB80))
        (close-output-port dop)
        (close-output-port top))
      (and verbose (printf "Dumping Ending\n"))
      #;-
      (let* ([dop (open-output-file "Ending.dump" #:mode 'text #:exists 'truncate)]
             [top (open-output-file "data-jp\\Ending.txt" #:mode 'text #:exists 'truncate)]
             [make-id
              (λ (addr)
                (format "Ending-~a" (format-snes-ptr addr)))]
             [make-dump-line
              (λ (addr ptrs)
                (format "(~a ~a #f ((~a ~a)))\n"
                        (make-id addr)
                        (snes-get-bank addr)
                        'write-16bits-ptrs
                        (format-snes-ptr-list ptrs)))]
             [dump-from-ptrs
              (λ (ptrs [bank #xB7] [num 1])
                (let ([addr (+ (arithmetic-shift bank 16) (read-word-at ip (snes-lorom-mapper (car ptrs))))])
                  (display (make-dump-line addr ptrs) dop)
                  (fprintf top "\n[BEGIN ~a]\n//" (make-id addr))
                  (display (read-string ip table addr) top)
                  (let loop ([n (sub1 num)])
                    (unless (zero? n)
                      (newline top)
                      (display "//" top)
                      (display (read-string ip table) top)
                      (loop (sub1 n))))
                  (fprintf top "\n~a<END>\n[END]\n" (make-id addr))))])
        (dump-from-ptrs '(#x82E8FD))
        (dump-from-ptrs '(#x82E923))
        (dump-from-ptrs '(#x82E951))
        (dump-from-ptrs '(#x82E9F8))
        (dump-from-ptrs '(#x82EA44))
        (dump-from-ptrs '(#x82EA90))
        (dump-from-ptrs '(#x81D1D1) #x81) ; TO BE CONTINUED
        (close-output-port dop)
        (close-output-port top))
      (and verbose (printf "Dumping Str_82B226\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #x82B226 read-16bits-ptr 10 ip)
                           "Str_82B226.dump"
                           "data-jp\\Str_82B226.txt"
                           (make-id-maker "Str_82B226")
                           (make-dump-line-maker 'write-16bits-ptrs #x82))
      (and verbose (printf "Dumping PlacesDebug\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #x82B306 read-16bits-ptr 56 ip)
                           "PlacesDebug.dump"
                           "data-jp\\PlacesDebug.txt"
                           (make-id-maker "PlacesDebug")
                           (make-dump-line-maker 'write-16bits-ptrs #x82))
      (and verbose (printf "Dumping Techs\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #x84B605 read-16bits-ptr 640 ip)
                           "Techs.dump"
                           "data-jp\\Techs.txt"
                           (make-id-maker "Techs")
                           (make-dump-line-maker 'write-16bits-ptrs #x84))
      (and verbose (printf "Dumping Places\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #x878000 read-16bits-ptr 100 ip)
                           "Places.dump"
                           "data-jp\\Places.txt"
                           (make-id-maker "Places")
                           (make-dump-line-maker 'write-16bits-ptrs #x87))
      (and verbose (printf "Dumping Choices\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #xA98000 read-16bits-ptr 117 ip)
                           "Choices.dump"
                           "data-jp\\Choices.txt"
                           (make-id-maker "Choices")
                           (make-dump-line-maker 'write-16bits-ptrs #xA9))
      (and verbose (printf "Dumping Chapters\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #xAD8000 read-16bits-ptr 204 ip)
                           "Chapters.dump"
                           "data-jp\\Chapters.txt"
                           (make-id-maker "Chapters")
                           (make-dump-line-maker 'write-16bits-ptrs #xAD))
      (and verbose (printf "Dumping Monters\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #xAEC910 read-16bits-ptr 55 ip)
                           "Monsters.dump"
                           "data-jp\\Monsters.txt"
                           (make-id-maker "Monsters")
                           (make-dump-line-maker 'write-16bits-ptrs #xAE))
      (and verbose (printf "Dumping BtlDlg\n"))
      (and verbose (printf "Dumping Songs\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #xB792BD read-16bits-ptr 21 ip)
                           "Songs.dump"
                           "data-jp\\Songs.txt"
                           (make-id-maker "Songs")
                           (make-dump-line-maker 'write-16bits-ptrs #xB7 `(right ,(* 15 8) 1)))
      (and verbose (printf "Dumping EndingCharNames\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #xB7DE49 read-16bits-ptr 29 ip)
                           "EndingCharNames.dump"
                           "data-jp\\EndingCharNames.txt"
                           (make-id-maker "EndingCharNames")
                           (make-dump-line-maker 'write-16bits-ptrs #xB7 `(center ,(* 32 8) 1)))
      (and verbose (printf "Dumping EndingCreditsText\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #xB7E529 read-16bits-ptr 23 ip)
                           "EndingCreditsText.dump"
                           "data-jp\\EndingCreditsText.txt"
                           (make-id-maker "EndingCreditsText")
                           (make-dump-line-maker 'write-16bits-ptrs #xB7 `(center ,(* 32 8) 11)))
      (table 'add-mapping #"\x0A\x00" (λ (c ip) (values #"\n//" #f)))
      (table 'add-mapping #"\x0A\x00\x0A\x00" (λ (c ip) (values #"<EOP>\n//" #f)))
      (table 'add-mapping #"\x0A\x00\x0A\x00\x0A\x00" (λ (c ip) (values #"<EOP>\n//" #f)))
      (and verbose (printf "Dumping SpecialStages\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #x988000 read-16bits-ptr 56 ip)
                           "SpecialStages.dump"
                           "data-jp\\SpecialStages.txt"
                           (make-id-maker "SpecialStages")
                           (make-dump-line-maker 'write-16bits-ptrs #x98 `(left ,(* 16 8) 3)))
      (and verbose (printf "Dumping Interlude\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #x9F8000 read-16bits-ptr 232 ip)
                           "Interlude.dump"
                           "data-jp\\Interlude.txt"
                           (make-id-maker "Interlude")
                           (make-dump-line-maker 'write-16bits-ptrs #x9F `(left ,(* 14 8) 3)))
      #;-
      (dump-from-ptr-table ip
                           table
                           (read-ptr-table #xB19C34 read-16bits-ptr 769 ip)
                           "BtlDlg.dump"
                           "data-jp\\BtlDlg.txt"
                           (make-id-maker "BtlDlg")
                           make-btldlg-dump-line)
      (and verbose (printf "Dumping Dialog\n"))
      #;-
      (dump-from-ptr-table ip
                           table
                           (append (read-ptr-table #xA88000 read-16bits-ptr 604 ip (λ (a i) i))
                                   (read-ptr-table #xA987D6 read-16bits-ptr 789 ip (λ (a i) (+ 604 i)))
                                   (read-ptr-table #xAB8000 read-16bits-ptr 683 ip (λ (a i) (+ 1393 i)))
                                   (read-ptr-table #x9D8000 read-16bits-ptr 585 ip (λ (a i) (+ 2076 i)))
                                   (read-ptr-table #x9E8000 read-16bits-ptr 610 ip (λ (a i) (+ 2661 i)))
                                   (read-ptr-table #xB28000 read-16bits-ptr 657 ip (λ (a i) (+ 3271 i)))
                                   (read-ptr-table #xB48000 read-16bits-ptr 711 ip (λ (a i) (+ 3928 i)))
                                   (read-ptr-table #xB58000 read-16bits-ptr 654 ip (λ (a i) (+ 4639 i)))
                                   (read-ptr-table #x8EB67A read-16bits-ptr 077 ip (λ (a i) (+ 5293 i))))
                           "Dialog.dump"
                           "data-jp\\Dialog.txt"
                           (make-id-maker "Dialog")
                           make-dialog-dump-line)
      ))
  #:mode 'binary)
