; The humble pope Neige the reversing schemer and avatar of lazyness
; officially declares this script inserter for Dragon Ball Z - Super Gokuuden Totsugeki Hen (J)
; to be (K) 3176 YOLD
; Do what thou wilt with thine copy

#lang scheme/base

(require scheme/port
         racket/format
         "libs/table.ss"
         "libs/memmap.ss"
         "libs/io.ss"
         "libs/space.ss")

;; fr en es, etc...
(define language "fr")

(define (localize-filename fn)
  (format fn language))

(define char-widths-file (localize-filename "data-~a/font.wid"))

(define table (make-table 'insertion))
(table 'read-table (localize-filename "data-~a/font.tbl"))

(set-default-mapper! snes-lorom-mapper)
(set-io-big-endian! #f)

(define fsh (make-free-space-handler))
(fsh 'add-list '((#x80A298 #x0020) ; was used by the "empty data" string
                 (#x80B53F #x0064) ; was used by the action screen strings
                 (#x80BA88 #x00A4) ; was used by the done screen strings
                 (#x80BE22 #x003E) ; was used by the clear screen page 2 strings
                 (#x80C1B4 #x0064) ; was used by the clear screen page 1 strings
                 (#x80C927 #x0018) ; was used by the start screen title string
                 (#x80C947 #x009C) ; was used by the start screen strings
                 ;(#x80F351 #x0C2F)
                 (#x80EF17 #x1099) ; first part was occupied by the new game strings
                 ;(#x80FF90 #x0020)
                 (#x81D1EE #x0022) ; old "TO BE CONTINUED" string
                 (#x81DCDB #x0274) ; old save/load strings 2
                 (#x81EEC8 #x1138)
                 (#x828E31 #x0074) ; old battle debug strings
                 (#x82AED0 #x02D6) ; old battle debug strings
                 (#x82F2FB #x0D05)
                 ;(#x838000 #x5E00) ; font gfx were stored here
                 (#x83C100 #x1D00) ; font gfx were stored here
                 (#x83FF96 #x006A)
                 (#x84BB05 #x0972) ; old tech names
                 (#x84E17D #x1E83)
                 (#x85F950 #x06B0)
                 (#x86DF12 #x20EE)
                 (#x8780C8 #x0518) ; old place names
                 (#x87F8A9 #x0757)
                 (#x88F958 #x06A8)
                 (#x89FE90 #x0170)
                 (#x8AFFF6 #x000A)
                 (#x8BFF86 #x007A)
                 (#x8CFFE6 #x001A)
                 (#x8DFECC #x0134)
                 (#x8EB67A #x1276) ; old dialog strings 8
                 (#x8EC8F0 #x00CA)
                 (#x8EF3AE #x0C52)
                 (#x8FF874 #x078C)
                 (#x90FA4C #x05B4)
                 (#x91FF56 #x00AA)
                 (#x92FD12 #x02EE)
                 (#x93FFD8 #x0028)
                 (#x94F394 #x0C6C)
                 (#x95F8F2 #x070E)
                 (#x96FCB4 #x034C)
                 (#x97FE46 #x01BA)
                 (#x988070 #x0692) ; old special stages strings
                 (#x98F902 #x06FE)
                 (#x99F9D8 #x0628)
                 (#x9AFEDE #x0122)
                 (#x9BF840 #x07C0)
                 (#x9CFE7E #x0182)
                 (#x9DBEEE #x4112) ; was old dialog strings 3, now #x9D8000-#x9DBEED is occupied by the new dialog pointers
                 (#x9E8000 #x8000) ; old dialog strings 4
                 (#x9F81D0 #x2848) ; old interlude strings
                 (#x9FFABE #x0542)
                 (#xA0FFF8 #x0008)
                 (#xA1FFDA #x0026)
                 (#xA2FFD8 #x0028)
                 (#xA3FFE0 #x0020)
                 (#xA4FFBA #x0046)
                 (#xA5FFCC #x0034)
                 (#xA6E57A #x1A86)
                 (#xA7F2CB #x0D35)
                 (#xA88000 #x8000) ; old dialog strings 0
                 (#xA980EA #x7F16) ; OldChoiceStrings + OldDialog1 + FreeSpaceBank29
                 (#xAAFED1 #x012F)
                 (#xAB8000 #x8000) ; old dialog strings 2
                 (#xACF948 #x06B8)
                 (#xAD8198 #x1276) ; old chapter names
                 (#xADF021 #x0FDF)
                 (#xAEC97E #x024C) ; old monster names
                 (#xAEE9E8 #x1618)
                 (#xAFFB34 #x04CC)
                 (#xB0FF71 #x008F)
                 (#xB1A236 #x5DCA) ; OldMonsterNames + FreeSpaceBank31
                 (#xB28000 #x8000) ; old dialog strings 5
                 (#xB3FE6C #x0194)
                 (#xB48000 #x8000) ; old dialog strings 6
                 (#xB58000 #x8000) ; old dialog strings 7
                 (#xB6E5A3 #x1A5D)
                 (#xB78E31 #x003C) ; old game over string
                 (#xB792E7 #x01DE) ; old song names strings
                 (#xB7DE83 #x05D8) ; old ending char names strings
                 (#xB7E45B #x00CE) ; old ending summary strings
                 (#xB7E557 #x0B48) ; old ending credits strings
                 (#xB7F49F #x0B61)
                 (#xB8F2B5 #x0D4B)
                 (#xB9FFE4 #x001C)
                 (#xBAFFF8 #x0008)
                 (#xBBFFBD #x0043)
                 (#xBCFFFA #x0006)
                 (#xBDFED1 #x012F)
                 (#xBEFFD9 #x0027)
                 (#xBF8000 #x8000) ; font gfx were stored here
                 ))

(define (get-total-free-space)
  (foldl (λ (p v) (+ (cdr p) v)) 0 (fsh 'dump)))
(printf "Total free space: ~a bytes\n" (get-total-free-space))

(define (snes-get-low addr)
  (bitwise-and addr #xFF))

(define (snes-get-high addr)
  (bitwise-and (arithmetic-shift addr -8) #xFF))

(define (snes-get-bank addr)
  (bitwise-and (arithmetic-shift addr -16) #xFF))

(define (write-24bits-ptrs op ptr ofs)
  (for-each (λ (c) (write-3bytes-at ptr op (snes-lorom-mapper c))) ofs))

(define (write-16bits-ptrs op ptr ofs)
  (for-each (λ (c) (write-word-at ptr op (snes-lorom-mapper c))) ofs))

(define (write-lows op ptr ofs)
  (for-each (λ (c) (write-byte-at (snes-get-low ptr) op (snes-lorom-mapper c))) ofs))

(define (write-highs op ptr ofs)
  (for-each (λ (c) (write-byte-at (snes-get-high ptr) op (snes-lorom-mapper c))) ofs))

(define (write-banks op ptr ofs)
  (for-each (λ (c) (write-byte-at (snes-get-bank ptr) op (snes-lorom-mapper c))) ofs))

(define-values (set-write-func! get-write-func)
  (let ([func-hash (make-hash)])
    (values
     (λ (s f)
       (hash-set! func-hash s f))
     (λ (s)
       (hash-ref func-hash s #f)))))

(set-write-func! 'write-24bits-ptrs write-24bits-ptrs)
(set-write-func! 'write-16bits-ptrs write-16bits-ptrs)
(set-write-func! 'write-lows write-lows)
(set-write-func! 'write-highs write-highs)
(set-write-func! 'write-banks write-banks)

(define (write-ptrs op ptr loo)
  (for-each (λ (c) (apply (get-write-func (car c)) op ptr (cdr c))) loo))

;==============================================================================

(define (bytes-empty? b)
  (zero? (bytes-length b)))

;; convert-string : table bytes bytes -> bytes
(define (convert-string table id s)
  (let convert-loop ([i 0])
    (if (= i (bytes-length s))
      #""
      (let match-loop ([len (min (table 'get-max-length (bytes-ref s i)) (- (bytes-length s) i))])
        (if (zero? len)
            (error 'convert-string "unknown code #x~x, index = ~a, string id ~a = [~a]" (bytes-ref s i) i id s)
            (let ([str-val (table 'get-mapping (subbytes s i (+ i len)) #f)])
              (if str-val
                  (bytes-append str-val (convert-loop (+ i len)))
                  (match-loop (sub1 len)))))))))


;; read-text-strings : input-port table -> hash
(define (read-text-strings ip table lsep)
  (let ([read-next-string-id
         (λ ()
           (let ([matched (regexp-match #px#"\\[BEGIN (.*?)\\]\n" ip)])
             (if matched
                 (string->symbol (bytes->string/latin-1 (cadr matched)))
                 #f)))]
        [read-next-string
         (λ ()
           (let ([str
                  (let rns-loop ([line (read-bytes-line ip 'linefeed)])
                    (cond
                      [(or (and (>= (bytes-length line) 5)
                                (bytes=? (subbytes line 0 5) #"[END]"))
                           (eof-object? line))
                       #""]
                      [(or (bytes-empty? line)
                           (bytes=? (subbytes line 0 2) #"//"))
                       (rns-loop (read-bytes-line ip 'linefeed))]
                      [else (bytes-append lsep line (rns-loop (read-bytes-line ip 'linefeed)))]))])
             (if (bytes-empty? str)
                 #f
                 (subbytes str (bytes-length lsep)))))]
        [hash (make-hash)])
    (let rts-loop ([id (read-next-string-id)])
      (when id
        (hash-set! hash id (convert-string table id (read-next-string)))
        (rts-loop (read-next-string-id))))
    hash))

;==============================================================================

;; get-char-width : byte -> integer
(define get-char-width
  (let ([widths
         (call-with-input-file char-widths-file
           (λ (ip) (read-bytes 256 ip))
           #:mode 'binary)])
    (λ (c)
      (bytes-ref widths c))))

;; word-length : bytes procedure -> number
(define (word-length s get-char-width)
  (if (bytes-empty? s) ; string empty
      0
      (+ (get-char-width (bytes-ref s 0))
         (word-length (subbytes s 1) get-char-width))))
;(word-length #"Hello " get-char-width)

;; get-fitting-string : bytes number procedure -> bytes bytes bytes
(define (get-fitting-string s length get-char-width)
  #;(printf "~s\n" s)
  (let loop ([s s] [len length] [line #""])
    (let*-values ([(matched) (regexp-match #rx#"(.*?)( |\3|\n)|(.*?)$" s)]
                  [(word sep) (values (if (cadr matched)
                                          (cadr matched)
                                          (cadddr matched))
                                      (caddr matched))])
      (cond
        [(and (not sep)
              (bytes-empty? word))
         (values line s #"")] ; end of bytes
        [(> (word-length word get-char-width) length)
         (values word
                 (subbytes s (bytes-length word))
                 (if (zero? (bytes-length line)) #"" #" "))] ; single word larger than length
        [(< len (+ (word-length word get-char-width) (get-char-width #x20)))
         (values line s #"\n")] ;  end of fitting words
        [(and sep
              (or (bytes=? sep #"\n")
                  (bytes=? sep #"\3")))
         (values (bytes-append line (if (zero? (bytes-length line)) #"" #" ") word)
                 (subbytes s (add1 (bytes-length word)))
                 sep)] ; explicit eol or eop
        [(bytes-empty? word)
         (loop (subbytes s (bytes-length sep))
               len
               line)] ; duplicate separator
        [else ;(printf "~s ~a ~a\n" word (word-length word get-char-width) (bytes-empty? line))
              (loop (subbytes s (bytes-length (car matched)))
                    (- len
                       (word-length word get-char-width)
                       (if (bytes-empty? line) 0 (get-char-width #x20)))
                    (bytes-append line (if (bytes-empty? line) #"" #" ") word))]))))
;(get-fitting-string #"test0 test1 test2 test3 test4" 150 get-char-width)
;(get-fitting-string #"test0 test1 test2 test3 test4" 500 get-char-width)

;; align-left : bytes number procedure -> bytes
(define (align-left s len get-char-width)
  (if (bytes-empty? s)
      #""
      (let-values ([(line words-left sep) (get-fitting-string s len get-char-width)])
        (bytes-append line
                      sep
                      (align-left words-left len get-char-width)))))
;(printf "[\n~a\n]\n" (align-left #"test0 test1 test2\xA0 test3 test4" 100 get-char-width))
;(printf "[\n~a\n]\n" (align-left #"test0 test1 test2 test3 test4" 150 get-char-width))

;; make-pad-string : number byte procedure -> bytes
(define (make-pad-string len get-char-width)
  (let loop ([len len] [pad-chars '(#x1F #x1E #x1D #x1C #x1B #x1A #x19 #x18 #x17 #x16 #x15 #x14 #x13 #x12 #x11 #x10)])
    #;(printf "len: ~a, char-len: ~a\n" len (if (null? pad-chars) 0 (get-char-width (car pad-chars))))
    (cond
      [(null? pad-chars) #""]
      [(< len (get-char-width (car pad-chars)))
       (loop len (cdr pad-chars))]
      [else (bytes-append (bytes (car pad-chars))
                          (loop (- len (get-char-width (car pad-chars)))
                                pad-chars))])))
;(make-pad-string 63 #x9 get-char-width)

;; align-center : bytes number procedure -> bytes
(define (align-center s len get-char-width)
    (if (bytes-empty? s)
        #""
        (let-values ([(line words-left sep) (get-fitting-string s len get-char-width)])
          (bytes-append (make-pad-string (/ (- len (word-length line get-char-width)) 2) get-char-width)
                        line
                        sep
                        (align-center words-left len get-char-width)))))
;(printf "[\n~a\n]\n" (align-center #"test0 test1 test2 test3 test4" 100 get-char-width))
;(printf "[\n~a\n]\n" (align-center #"test0 test1 test2 test3 test4" 150 get-char-width))

;; align-right : bytes number procedure -> bytes
(define (align-right s len get-char-width)
    (if (bytes-empty? s)
        #""
        (let-values ([(line words-left sep) (get-fitting-string s len get-char-width)])
          (bytes-append (make-pad-string (- len (word-length line get-char-width)) get-char-width)
                        line
                        sep #;(if (bytes-empty? words-left) #"" #"\n")
                        (align-right words-left len get-char-width)))))
;(printf "[\n~a\n]\n" (align-right #"test0 test1 test2 test3 test4" 100 get-char-width))
;(printf "[\n~a\n]\n" (align-right #"test0 test1 test2 test3 test4" 150 get-char-width))

(define (align str type width height)
  (let ([align-func (case type
                      [(left) align-left]
                      [(center) align-center]
                      [(right) align-right]
                      [else #f])])
    (align-func str width get-char-width)))

;==============================================================================

;; insert-string : bytes output-port -> integer or #f
;; Attempts to insert the string anywhere and return the offset if successful, #f otherwise
(define (insert-string s dest op)
  (let* ([size (bytes-length s)]
         [ofs (cond
                [(eq? dest #f)
                 (fsh 'request-anywhere size)]
                [(<= 0 dest 255)
                 (let ([base (arithmetic-shift dest 16)])
                   (fsh 'request-in-range (+ base #x8000) (+ base #xFFFF) size))]
                [(integer? dest)
                 (fsh 'request-at dest size)]
                [else
                 (error 'insert-string "wrong destination specification ~a. expected #f, byte? or integer?" dest)])])
    (if ofs
        (begin
          (io-at op (snes-lorom-mapper ofs) (λ (op) (write-bytes s op)))
          (fsh 'update ofs size)
          ofs)
        #f)))

;; open-output-file-bytes : path-string? -> output-port?
;; Return a byte output port containing all the bytes in file fn
(define (open-output-file-bytes fn)
  (let ([obp (open-output-bytes)])
    (call/if fn
      (λ (ip)
        (copy-port ip obp))
      #:mode 'binary)
    obp))

(define (call/ofb path proc)
  (unless (path-string? path)
    (raise-type-error 'call/ofb "path or string" path))
  (unless (and (procedure? proc)
               (procedure-arity-includes? proc 1))
    (raise-type-error 'call/ofb "procedure (arity 1)" proc))
  (let ([p (open-output-file-bytes path)])
    (proc p)
    (call/of path
      (λ (op)
        (write-bytes (get-output-bytes p) op))
      #:mode 'binary
      #:exists 'truncate)
    (close-output-port p)))

(define (dump-id dump)
  (car dump))

(define (dump-dest dump)
  (cadr dump))

(define (dump-align-args dump)
  (caddr dump))

(define (dump-pointers dump)
  (cadddr dump))

;; insert-script : output-port? table path-string? path-string? path-string? -> any
(define (insert-script op table dump text [log #f] [lsep #" "])
  (let* ([dip (open-input-file dump #:mode 'text)]
         [tip (open-input-file text #:mode 'text)]
         [lop (if log (open-output-file log #:mode 'text #:exists 'truncate) #f)]
         [text-strings (read-text-strings tip table lsep)])
    (let is-loop ([dump-info (read dip)] [uniques (make-immutable-hash '())])
      (unless (eof-object? dump-info)
        (let* ([str-id (dump-id dump-info)]
               [raw-str (hash-ref text-strings str-id #f)]
               [str (if (and raw-str
                             (dump-align-args dump-info))
                        (apply align raw-str (dump-align-args dump-info))
                        raw-str)]
               [ofs (cond
                      [(hash-ref uniques raw-str #f)]
                      [raw-str (insert-string (if (dump-align-args dump-info)
                                                  (apply align raw-str (dump-align-args dump-info))
                                                  raw-str)
                                              (dump-dest dump-info)
                                              op)]
                      [else (error 'insert-script "invalid string id ~a" str-id)])])
          (if ofs
              (begin
                (write-ptrs op ofs (dump-pointers dump-info))
                (and lop (fprintf lop "Wrote string id ~a at #x~x\n" str-id (~r ofs #:base '(up 16) #:min-width 6 #:pad-string "0"))))
              (error 'insert-script "no free space to insert string (id ~a)" str-id))
          (is-loop (read dip) (hash-set uniques raw-str ofs)))))
    (close-input-port dip)
    (close-input-port tip)
    (and lop (close-output-port lop))))

(call/ofb (localize-filename "dbz-sgth-~a.smc")
  (λ (op)
    (insert-script op table "DebugMenu-mod.dump" (localize-filename "data-~a/DebugMenu.txt") #f #;"DebugMenu.log" #"")
    (insert-script op table "NewGame-mod.dump" (localize-filename "data-~a/NewGame.txt") #f #;"NewGame.log" #"")
    (insert-script op table "LoadSave-mod.dump" (localize-filename "data-~a/LoadSave.txt") #f #;"LoadSave.log" #"")
    (insert-script op table "StartScreen-mod.dump" (localize-filename "data-~a/StartScreen.txt") #f #;"StartScreen.log" #"")
    (insert-script op table "Battle-mod.dump" (localize-filename "data-~a/Battle.txt") #f #;"Battle.log" #"")
    (insert-script op table "Piccolo.dump" (localize-filename "data-~a/Piccolo.txt") #f #;"Piccolo.log" #"")
    (insert-script op table "Ending-mod.dump" (localize-filename "data-~a/Ending.txt") #f #;"Ending.log" #"")
    (insert-script op table "Songs.dump" (localize-filename "data-~a/Songs.txt") #;"Songs.log")
    (insert-script op table "Chapters.dump" (localize-filename "data-~a/Chapters.txt") #;"Chapters.log")
    (insert-script op table "BtlDlg.dump" (localize-filename "data-~a/BtlDlg.txt") #;"BtlDlg.log")
    (insert-script op table "Choices.dump" (localize-filename "data-~a/Choices.txt") #;"Choices.log")
    (insert-script op table "Monsters.dump" (localize-filename "data-~a/Monsters.txt") #;"Monsters.log")
    (insert-script op table "SpecialStages.dump" (localize-filename "data-~a/SpecialStages.txt") #;"SpecialStages.log")
    (insert-script op table "Interlude.dump" (localize-filename "data-~a/Interlude.txt") #;"Interlude.log")
    (insert-script op table "Places.dump" (localize-filename "data-~a/Places.txt") #;"Places.log")
    (insert-script op table "Techs.dump" (localize-filename "data-~a/Techs.txt") #;"Techs.log")
    (insert-script op table "EndingCharNames.dump" (localize-filename "data-~a/EndingCharNames.txt") #;"EndingCharNames.log")
    (insert-script op table "EndingCreditsText.dump" (localize-filename "data-~a/EndingCreditsText.txt") #;"EndingCreditsText.log")
    (insert-script op table "Dialog.dump" (localize-filename "data-~a/Dialog.txt") #;"dialog.log")
    ))
(printf "Free space left: ~a bytes\n" (get-total-free-space))

